package cn.com.infosec.math.ec;

import java.math.BigInteger;

class FpNafMultiplier implements ECMultiplier {
   public ECPoint multiply(ECPoint p, BigInteger k, PreCompInfo preCompInfo) {
      BigInteger var7 = k.multiply(BigInteger.valueOf(3L));
      ECPoint preCompInfo1 = p.negate();
      int var4 = var7.bitLength() - 2;

      ECPoint var5;
      for(var5 = p; var4 > 0; --var4) {
         var5 = var5.twice();
         boolean var6;
         if ((var6 = var7.testBit(var4)) != k.testBit(var4)) {
            ECPoint var9;
            if (var6) {
               var9 = p;
            } else {
               var9 = preCompInfo1;
            }

            var5 = var5.add(var9);
         }
      }

      return var5;
   }
}
